

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.analyze.changedetection &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../index.html"/>
        <link rel="up" title="Module code" href="../../index.html"/> 

  
  <script src="../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.analyze.changedetection</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.analyze.changedetection</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">from</span> <span class="nn">d2o.prep.scaling</span> <span class="kn">import</span> <span class="n">Scaler</span>
<span class="kn">from</span> <span class="nn">d2o.utils.handlers</span> <span class="kn">import</span> <span class="n">ExceptionHandler</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">logger</span> <span class="k">as</span> <span class="n">log</span>
<span class="kn">from</span> <span class="nn">d2o.prep</span> <span class="kn">import</span> <span class="n">scaling</span>

<span class="kn">from</span> <span class="nn">matplotlib.colors</span> <span class="kn">import</span> <span class="n">hsv_to_rgb</span><span class="p">,</span> <span class="n">hex2color</span><span class="p">,</span> <span class="n">rgb2hex</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span><span class="p">,</span> <span class="n">timedelta</span>
<span class="kn">import</span> <span class="nn">sklearn.preprocessing</span> <span class="kn">as</span> <span class="nn">pre</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>

<span class="kn">import</span> <span class="nn">matplotlib</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">itertools</span>
<span class="kn">import</span> <span class="nn">copy</span>

<span class="n">MIN_PERIOD_LENGTH</span>      <span class="o">=</span> <span class="mi">8</span>
<span class="n">MAX_TOPS</span>               <span class="o">=</span> <span class="mi">2</span>
<span class="n">CP_DISTANCE</span>            <span class="o">=</span> <span class="mi">7</span>

<span class="n">SEAM_SIZE_PERCENT</span> <span class="o">=</span> <span class="mf">0.2</span>

<span class="n">rn_ranges</span> <span class="o">=</span> <span class="p">{</span>
  <span class="o">.</span><span class="mi">90</span><span class="p">:</span><span class="s1">&#39;peak&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">70</span><span class="p">:</span><span class="s1">&#39;high&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">50</span><span class="p">:</span><span class="s1">&#39;medium&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">30</span><span class="p">:</span><span class="s1">&#39;low&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">10</span><span class="p">:</span><span class="s1">&#39;dip&#39;</span>
  <span class="p">}</span>

<span class="n">rv_ranges</span> <span class="o">=</span> <span class="p">{</span>
  <span class="o">.</span><span class="mi">90</span><span class="p">:</span><span class="s1">&#39;expensive&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">70</span><span class="p">:</span><span class="s1">&#39;above&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">50</span><span class="p">:</span><span class="s1">&#39;normal&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">30</span><span class="p">:</span><span class="s1">&#39;below&#39;</span><span class="p">,</span>
  <span class="o">.</span><span class="mi">10</span><span class="p">:</span><span class="s1">&#39;cheap&#39;</span>
  <span class="p">}</span>

<div class="viewcode-block" id="get_closest_in_range"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.get_closest_in_range">[docs]</a><span class="k">def</span> <span class="nf">get_closest_in_range</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">rv</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
  <span class="sd">&quot;&quot;&quot; Calculates the corresponding value in rn_ranges and</span>
<span class="sd">  rv_ranges. Used to map the real value to a smaller range.</span>

<span class="sd">  :param val: Value, revenue or room nights</span>
<span class="sd">  :returns: tuple(key of the closest value, closest value)</span>
<span class="sd">  &quot;&quot;&quot;</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">rv</span><span class="p">):</span>
    <span class="n">closest_val</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">rv_ranges</span><span class="o">.</span><span class="n">keys</span><span class="p">(),</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span><span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="o">-</span><span class="n">val</span><span class="p">))</span>
    <span class="n">closest_key</span> <span class="o">=</span> <span class="n">rv_ranges</span><span class="p">[</span><span class="n">closest_val</span><span class="p">]</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="n">closest_val</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">rn_ranges</span><span class="o">.</span><span class="n">keys</span><span class="p">(),</span> <span class="n">key</span><span class="o">=</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span><span class="nb">abs</span><span class="p">(</span><span class="n">x</span><span class="o">-</span><span class="n">val</span><span class="p">))</span>
    <span class="n">closest_key</span> <span class="o">=</span> <span class="n">rn_ranges</span><span class="p">[</span><span class="n">closest_val</span><span class="p">]</span>
  <span class="k">return</span> <span class="p">(</span><span class="n">closest_key</span><span class="p">,</span> <span class="n">closest_val</span><span class="p">)</span></div>

<div class="viewcode-block" id="Period"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period">[docs]</a><span class="k">class</span> <span class="nc">Period</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot; Period/Season definition.</span>
<span class="sd">  Contains the start, end and length of the period.</span>
<span class="sd">  A copy of the underlying dataframe is added in order to perform</span>
<span class="sd">  per-period calculations.</span>
<span class="sd">  &quot;&quot;&quot;</span>

  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">x1</span><span class="p">,</span> <span class="n">df</span><span class="o">=</span><span class="p">[]):</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">x0</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">x1</span> <span class="o">=</span> <span class="n">x1</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">df</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">median_sig</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">avg_sig</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="bp">None</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">rgb</span>  <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([])</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">hex</span> <span class="o">=</span> <span class="bp">None</span>

<div class="viewcode-block" id="Period.length"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.length">[docs]</a>  <span class="k">def</span> <span class="nf">length</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculate season length:</span>
<span class="sd">    :returns:       Season length</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="nb">abs</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">)</span></div>

<div class="viewcode-block" id="Period.middle"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.middle">[docs]</a>  <span class="k">def</span> <span class="nf">middle</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculate season center point:</span>
<span class="sd">    :returns:       Season center point</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">)</span><span class="o">/</span><span class="mf">2.0</span></div>

<div class="viewcode-block" id="Period.add_vspan"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.add_vspan">[docs]</a>  <span class="k">def</span> <span class="nf">add_vspan</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">pltobj</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Add a matplotlib vspan (graphical glyph).</span>
<span class="sd">    Used for storing color and handles color conversion.</span>
<span class="sd">    :param pltobj: matplotlib plot object (plt)</span>
<span class="sd">    :returns:       Matplotlib vspan</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span> <span class="o">=</span> <span class="n">pltobj</span><span class="o">.</span><span class="n">axvspan</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.7</span><span class="p">)</span>
    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="o">.</span><span class="n">size</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span><span class="o">.</span><span class="n">set_color</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="p">)</span>
    <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span></div>

<div class="viewcode-block" id="Period.update_pos"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.update_pos">[docs]</a>  <span class="k">def</span> <span class="nf">update_pos</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">x</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Update period position</span>
<span class="sd">    :param x: tuple or list [start,end]</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">x1</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">y0</span> <span class="o">=</span> <span class="mf">0.0</span>
    <span class="n">y1</span> <span class="o">=</span> <span class="mf">1.0</span>

    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">vspan</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">):</span>
      <span class="n">xy</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span>
        <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span><span class="n">y0</span><span class="p">],</span>
        <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span><span class="n">y1</span><span class="p">],</span>
        <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">,</span><span class="n">y1</span><span class="p">],</span>
        <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">,</span><span class="n">y0</span><span class="p">],</span>
        <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span><span class="n">y0</span><span class="p">]])</span>

      <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span><span class="o">.</span><span class="n">xy</span> <span class="o">=</span> <span class="n">xy</span></div>

<div class="viewcode-block" id="Period.update_color"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.update_color">[docs]</a>  <span class="k">def</span> <span class="nf">update_color</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">color_cols</span><span class="o">=</span><span class="p">[</span><span class="bp">None</span><span class="p">,</span><span class="bp">None</span><span class="p">,</span><span class="bp">None</span><span class="p">],</span> <span class="n">color_map</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Period color</span>
<span class="sd">    :param color_cols: The columns in the underlying dataframe wich corresponds to [RGB] or [HSV].</span>
<span class="sd">    :param color_map: deprecated, loaded from config. Contains hex vals for coloring.</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">color_map</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">):</span>
      <span class="n">rn_n</span> <span class="o">=</span> <span class="bp">None</span>
      <span class="n">rv_n</span> <span class="o">=</span> <span class="bp">None</span>
      <span class="k">for</span> <span class="n">key</span><span class="p">,</span><span class="n">val</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">median_sig</span><span class="o">.</span><span class="n">iteritems</span><span class="p">():</span>
        <span class="k">if</span> <span class="p">(</span><span class="s1">&#39;rate&#39;</span> <span class="ow">in</span> <span class="n">key</span><span class="o">.</span><span class="n">lower</span><span class="p">()):</span>
          <span class="n">rv_n</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">rv</span><span class="o">=</span><span class="bp">True</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
          <span class="n">rn_n</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">rv</span><span class="o">=</span><span class="bp">False</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>

      <span class="bp">self</span><span class="o">.</span><span class="n">hex</span> <span class="o">=</span> <span class="n">color_map</span><span class="p">[</span><span class="n">rn_n</span><span class="p">][</span><span class="n">rv_n</span><span class="p">]</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">rgb</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">hex2color</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">hex</span><span class="p">))</span>

    <span class="k">elif</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
      <span class="n">h</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">]))[</span><span class="mi">1</span><span class="p">]</span> <span class="k">if</span> <span class="p">(</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">)</span> <span class="k">else</span> <span class="mf">1.0</span>
      <span class="n">s</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">]))[</span><span class="mi">1</span><span class="p">]</span> <span class="k">if</span> <span class="p">(</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">)</span> <span class="k">else</span> <span class="mf">1.0</span>
      <span class="n">v</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">2</span><span class="p">]]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">]))[</span><span class="mi">1</span><span class="p">]</span> <span class="k">if</span> <span class="p">(</span><span class="n">color_cols</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">)</span> <span class="k">else</span> <span class="mf">1.0</span>

      <span class="n">hsv_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">h</span><span class="p">,</span><span class="n">s</span><span class="p">,</span><span class="n">v</span><span class="p">])</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">rgb</span> <span class="o">=</span> <span class="n">hsv_to_rgb</span><span class="p">(</span><span class="n">hsv_array</span><span class="p">)</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">hex</span> <span class="o">=</span> <span class="n">rgb2hex</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="p">)</span>
    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">vspan</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">vspan</span><span class="o">.</span><span class="n">set_color</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="p">)</span></div>

<div class="viewcode-block" id="Period.update"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.update">[docs]</a>  <span class="k">def</span> <span class="nf">update</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cols</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Update period signature</span>
<span class="sd">    :param cols: The columns to be used for signature definition</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">sig_dict</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">col</span> <span class="ow">in</span> <span class="n">cols</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">col</span> <span class="o">==</span> <span class="bp">None</span><span class="p">):</span>
        <span class="k">continue</span>
      <span class="n">sig_dict</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">col</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">])</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">median_sig</span> <span class="o">=</span> <span class="n">sig_dict</span>

    <span class="c1"># Avg sig</span>
    <span class="n">sig_dict</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="k">for</span> <span class="n">col</span> <span class="ow">in</span> <span class="n">cols</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">col</span> <span class="o">==</span> <span class="bp">None</span><span class="p">):</span>
        <span class="k">continue</span>
      <span class="n">sig_dict</span><span class="p">[</span><span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">col</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()[</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">])</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">avg_sig</span> <span class="o">=</span> <span class="n">sig_dict</span>

    <span class="c1"># Name</span>
    <span class="n">avg</span>    <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">median_sig</span>
    <span class="n">names</span>  <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">key</span><span class="p">,</span><span class="n">val</span> <span class="ow">in</span> <span class="n">avg</span><span class="o">.</span><span class="n">iteritems</span><span class="p">():</span>
      <span class="n">identifier</span> <span class="o">=</span> <span class="n">key</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">identifier</span> <span class="o">==</span> <span class="s1">&#39;Rate&#39;</span><span class="p">):</span>
        <span class="n">identifier</span> <span class="o">=</span> <span class="s1">&#39;ARR&#39;</span>
      <span class="k">elif</span> <span class="p">(</span><span class="n">identifier</span> <span class="o">==</span> <span class="s1">&#39;Room Nights&#39;</span><span class="p">):</span>
        <span class="n">identifier</span> <span class="o">=</span> <span class="s1">&#39;%&#39;</span>

      <span class="k">if</span> <span class="p">(</span><span class="s1">&#39;rate&#39;</span> <span class="ow">in</span> <span class="n">key</span><span class="o">.</span><span class="n">lower</span><span class="p">()):</span>
        <span class="n">n</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">rv</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
      <span class="k">else</span><span class="p">:</span>
        <span class="n">n</span> <span class="o">=</span> <span class="n">get_closest_in_range</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">rv</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
      <span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;{0}: {1}&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">identifier</span><span class="p">,</span><span class="n">n</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">title</span><span class="p">())</span>
      <span class="n">names</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
    <span class="n">ret</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">names</span><span class="p">)</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">ret</span></div>

<div class="viewcode-block" id="Period.rgb_string"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.Period.rgb_string">[docs]</a>  <span class="k">def</span> <span class="nf">rgb_string</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; String representation of the period RGB color</span>
<span class="sd">    :returns:       String &#39;r,g,b&#39;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="s1">&#39;r:</span><span class="si">%s</span><span class="s1">, g:</span><span class="si">%s</span><span class="s1">, b:</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="nb">tuple</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="p">)</span></div>

  <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">s</span>  <span class="o">=</span> <span class="s2">&quot;Coords: </span><span class="si">%s</span><span class="s2"> -&gt; </span><span class="si">%s</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">x1</span><span class="p">)</span>
    <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;Msig  : </span><span class="si">%s</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">median_sig</span><span class="p">)</span>
    <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;Asig  : </span><span class="si">%s</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">avg_sig</span><span class="p">)</span>
    <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;Color : </span><span class="si">%s</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">rgb</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">s</span></div>


<div class="viewcode-block" id="ZScoreDetector"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector">[docs]</a><span class="k">class</span> <span class="nc">ZScoreDetector</span><span class="p">():</span>
  <span class="sd">&quot;&quot;&quot; Detects changepoints and calculates similar changing periods in a timeseries.</span>
<span class="sd">  TODO: Tailored for d2o, needs to be generalized</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">color_cols</span><span class="o">=</span><span class="p">[],</span> <span class="n">color_map</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">circular</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">is_circular</span> <span class="o">=</span> <span class="n">circular</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">overlap</span> <span class="o">=</span> <span class="bp">None</span>

    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">is_circular</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">overlap</span> <span class="o">=</span> <span class="n">df</span><span class="p">[:</span><span class="mi">60</span><span class="p">]</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">overlap</span><span class="o">.</span><span class="n">index</span> <span class="o">+=</span> <span class="mi">366</span>
      <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">concat</span><span class="p">([</span><span class="n">df</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">overlap</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">color_cols</span><span class="p">)</span> <span class="o">==</span> <span class="mi">3</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">use_colors</span>  <span class="o">=</span> <span class="bp">True</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span> <span class="o">=</span> <span class="n">color_cols</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">use_colors</span> <span class="o">=</span> <span class="bp">False</span>

    <span class="k">if</span> <span class="p">(</span><span class="n">color_map</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">color_map</span> <span class="o">=</span> <span class="n">color_map</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">color_map</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;peak&#39;</span>  <span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#98edb5&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#9de6fe&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#fffeab&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#ffc0a4&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#ff96d1&#39;</span> <span class="p">},</span>
        <span class="s1">&#39;high&#39;</span>  <span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#88d63c&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#3fcdfd&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#fffe69&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#fb9262&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#fc4eb0&#39;</span> <span class="p">},</span>
        <span class="s1">&#39;medium&#39;</span><span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#3cc923&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#3d8ddc&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#f1ef00&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#fc6621&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#d8017a&#39;</span> <span class="p">},</span>
        <span class="s1">&#39;low&#39;</span>   <span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#20a308&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#454ea0&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#ffdd1c&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#d85013&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#a0300e&#39;</span> <span class="p">},</span>
        <span class="s1">&#39;low&#39;</span>   <span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#20a308&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#454ea0&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#ffdd1c&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#db650a&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#e4000d&#39;</span> <span class="p">},</span>
        <span class="s1">&#39;dip&#39;</span>   <span class="p">:</span> <span class="p">{</span><span class="s1">&#39;expensive&#39;</span><span class="p">:</span><span class="s1">&#39;#026f02&#39;</span><span class="p">,</span> <span class="s1">&#39;above&#39;</span><span class="p">:</span><span class="s1">&#39;#0515a9&#39;</span><span class="p">,</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span><span class="s1">&#39;#d4b400&#39;</span><span class="p">,</span> <span class="s1">&#39;below&#39;</span><span class="p">:</span><span class="s1">&#39;#9d4b00&#39;</span><span class="p">,</span> <span class="s1">&#39;cheap&#39;</span><span class="p">:</span><span class="s1">&#39;#97040c&#39;</span> <span class="p">}</span>
        <span class="p">}</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">df</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">y</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span> <span class="o">=</span> <span class="bp">None</span>

<div class="viewcode-block" id="ZScoreDetector.calculate_zscores"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.calculate_zscores">[docs]</a>  <span class="k">def</span> <span class="nf">calculate_zscores</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">iwindow_size</span><span class="p">,</span> <span class="n">owindow_size</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculates z-scores by running an inner and outer window over</span>
<span class="sd">    the underlying timeseries (y)</span>
<span class="sd">    :param iwindow_size: inner window size</span>
<span class="sd">    :param owindow_size: outer window size</span>
<span class="sd">    :returns:       List of z-scores (same length as y)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">z_scores</span> <span class="o">=</span> <span class="p">[</span><span class="mf">0.0</span><span class="p">]</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)):</span>
      <span class="n">ostart</span>  <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="o">-</span><span class="n">owindow_size</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">ostart</span>  <span class="o">=</span> <span class="n">ostart</span> <span class="k">if</span>  <span class="p">(</span><span class="n">ostart</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">)</span> <span class="k">else</span> <span class="mi">0</span>
      <span class="n">oend</span>    <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="n">owindow_size</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">oend</span>    <span class="o">=</span> <span class="n">oend</span> <span class="k">if</span> <span class="p">(</span><span class="n">oend</span> <span class="o">&lt;</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">))</span> <span class="k">else</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
      <span class="n">owindow</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">[</span><span class="n">ostart</span><span class="p">:</span><span class="n">oend</span><span class="p">]</span>

      <span class="n">iend</span>    <span class="o">=</span> <span class="n">i</span> <span class="o">+</span> <span class="nb">int</span><span class="p">(</span><span class="n">iwindow_size</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
      <span class="c1">#iend    = i+int(iwindow_size)</span>
      <span class="n">iend</span>    <span class="o">=</span> <span class="n">iend</span> <span class="k">if</span> <span class="p">(</span><span class="n">iend</span> <span class="o">&lt;</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">))</span> <span class="k">else</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
      <span class="n">istart</span>  <span class="o">=</span> <span class="n">i</span> <span class="o">-</span> <span class="nb">int</span><span class="p">(</span><span class="n">iwindow_size</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
      <span class="c1">#istart  = ostart</span>
      <span class="n">istart</span>  <span class="o">=</span> <span class="n">istart</span> <span class="k">if</span> <span class="p">(</span><span class="n">istart</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">)</span> <span class="k">else</span> <span class="mi">0</span>
      <span class="n">iwindow</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">[</span><span class="n">istart</span><span class="p">:</span><span class="n">iend</span><span class="p">]</span>

      <span class="n">iwindow_mean</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">iwindow</span><span class="p">)</span>
      <span class="n">iwindow_std</span>  <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">std</span><span class="p">(</span><span class="n">iwindow</span><span class="p">)</span>

      <span class="n">owindow_mean</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">owindow</span><span class="p">)</span>
      <span class="n">owindow_std</span>  <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">std</span><span class="p">(</span><span class="n">owindow</span><span class="p">)</span>

      <span class="n">SE</span> <span class="o">=</span> <span class="n">iwindow_std</span><span class="o">/</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">iwindow</span><span class="p">))</span>
      <span class="n">zs</span> <span class="o">=</span> <span class="p">(</span><span class="n">iwindow_mean</span> <span class="o">-</span> <span class="n">owindow_mean</span><span class="p">)</span><span class="o">/</span><span class="n">SE</span> <span class="k">if</span> <span class="p">(</span><span class="n">SE</span> <span class="o">&gt;</span> <span class="mf">0.0</span><span class="p">)</span> <span class="k">else</span> <span class="mf">0.0</span>

      <span class="n">z_scores</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">zs</span><span class="p">)</span>

      <span class="c1"># try:</span>
      <span class="c1">#   z_scores[i-1] = z_scores[i-1] + np.abs(zs)/1.5</span>
      <span class="c1"># except:</span>
      <span class="c1">#   pass</span>
    <span class="k">return</span> <span class="n">z_scores</span></div>

<div class="viewcode-block" id="ZScoreDetector.add_padding"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.add_padding">[docs]</a>  <span class="k">def</span> <span class="nf">add_padding</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">window</span><span class="p">,</span> <span class="n">padding_size</span><span class="p">,</span> <span class="n">min_size</span><span class="p">,</span> <span class="n">max_size</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Adds padding to the window.</span>
<span class="sd">    Padding is clamped to [min_size, max_size]</span>

<span class="sd">    :param window: Current window</span>
<span class="sd">    :param padding_size: size of padding (number of datapoints)</span>
<span class="sd">    :param min_size: clamp to this if smaller</span>
<span class="sd">    :param max_size: clamp to this if larger</span>
<span class="sd">    :returns:       A new window with padding addded</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">window</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">window</span><span class="p">)))</span>
    <span class="n">wstart</span> <span class="o">=</span> <span class="n">window</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">wend</span>   <span class="o">=</span> <span class="n">window</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">head</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">tail</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">padding_size</span><span class="p">):</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">wstart</span><span class="o">-</span><span class="n">i</span> <span class="o">&gt;=</span> <span class="n">min_size</span><span class="p">):</span>
        <span class="n">head</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">wstart</span><span class="o">-</span><span class="n">i</span><span class="p">)</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">wend</span><span class="o">+</span><span class="n">i</span> <span class="o">&lt;=</span> <span class="n">max_size</span><span class="p">):</span>
        <span class="n">tail</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">wend</span><span class="o">+</span><span class="n">i</span><span class="p">)</span>
    <span class="n">window</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">head</span> <span class="o">+</span> <span class="n">window</span> <span class="o">+</span> <span class="n">tail</span><span class="p">)))</span>
    <span class="k">return</span> <span class="n">window</span></div>

<div class="viewcode-block" id="ZScoreDetector.calculate_change_windows"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.calculate_change_windows">[docs]</a>  <span class="k">def</span> <span class="nf">calculate_change_windows</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">z_scores</span><span class="p">,</span> <span class="n">owindow_size</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculate the position of the change windows based on</span>
<span class="sd">    z-scores.</span>

<span class="sd">    :param z_scores: List of z_scores</span>
<span class="sd">    :param owindow_size: Size of outer window</span>
<span class="sd">    :returns:       A list of windows</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">windows</span>     <span class="o">=</span> <span class="p">[]</span>
    <span class="n">curr_window</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)):</span>
      <span class="n">wstart</span> <span class="o">=</span> <span class="n">i</span> <span class="o">-</span> <span class="n">owindow_size</span><span class="o">/</span><span class="mi">2</span>
      <span class="n">wend</span>   <span class="o">=</span> <span class="n">i</span> <span class="o">+</span> <span class="n">owindow_size</span><span class="o">/</span><span class="mi">2</span>
      <span class="n">wstart</span> <span class="o">=</span> <span class="n">wstart</span> <span class="k">if</span> <span class="n">wstart</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="k">else</span> <span class="mi">0</span>
      <span class="n">wend</span>   <span class="o">=</span> <span class="n">wend</span> <span class="k">if</span> <span class="p">(</span><span class="n">wend</span> <span class="o">&lt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">z_scores</span><span class="p">))</span> <span class="k">else</span> <span class="nb">len</span><span class="p">(</span><span class="n">z_scores</span><span class="p">)</span>

      <span class="n">window_zscores</span> <span class="o">=</span> <span class="n">z_scores</span><span class="p">[</span><span class="n">wstart</span><span class="p">:</span><span class="n">wend</span><span class="p">]</span>
      <span class="n">z_treshold</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="n">window_zscores</span><span class="p">)</span><span class="o">/</span><span class="mf">1.5</span>

      <span class="k">if</span> <span class="p">(</span><span class="n">z_scores</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="n">z_treshold</span><span class="p">):</span>
        <span class="n">curr_window</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
      <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">curr_window</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
          <span class="n">curr_window</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">add_padding</span><span class="p">(</span><span class="n">curr_window</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">))</span>
          <span class="n">windows</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">curr_window</span><span class="p">)</span>
          <span class="n">curr_window</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">return</span> <span class="n">windows</span></div>

<div class="viewcode-block" id="ZScoreDetector.calculate_changepoints"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.calculate_changepoints">[docs]</a>  <span class="k">def</span> <span class="nf">calculate_changepoints</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">windows</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculate changepoints per window.</span>

<span class="sd">    :param windows: list of windows</span>
<span class="sd">    :returns:       Changepoints</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">cps</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">windows</span><span class="p">:</span>
      <span class="k">try</span><span class="p">:</span>
        <span class="n">diff_range</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span><span class="p">[</span><span class="n">w</span><span class="p">[</span><span class="mi">0</span><span class="p">]:</span><span class="n">w</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span>
        <span class="n">sorted_diff_range</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">diff_range</span><span class="p">,</span> <span class="n">reverse</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
        <span class="n">diff_threshold</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">diffs</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">MAX_TOPS</span><span class="p">):</span>
          <span class="n">top</span> <span class="o">=</span> <span class="n">sorted_diff_range</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
          <span class="k">if</span> <span class="p">(</span><span class="n">top</span> <span class="o">&gt;</span> <span class="n">diff_threshold</span><span class="p">):</span>
            <span class="n">index</span> <span class="o">=</span> <span class="n">w</span><span class="p">[</span><span class="n">diff_range</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">top</span><span class="p">)]</span>
            <span class="n">cps</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">index</span><span class="p">)</span>
      <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">log</span><span class="o">.</span><span class="n">dbg</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>
        <span class="k">continue</span>

    <span class="n">cps</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">([</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">cps</span> <span class="o">+</span> <span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">])))</span>
    <span class="k">return</span> <span class="n">cps</span></div>

<div class="viewcode-block" id="ZScoreDetector.define_periods"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.define_periods">[docs]</a>  <span class="k">def</span> <span class="nf">define_periods</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">changepoints</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Calculate periods/seasons based on changepoints.</span>

<span class="sd">    :param changepoints: List of changepoints</span>
<span class="sd">    :returns:       List of Period objects</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">periods</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">delims</span> <span class="o">=</span> <span class="p">[(</span><span class="n">changepoints</span><span class="p">[</span><span class="n">j</span><span class="p">],</span> <span class="n">changepoints</span><span class="p">[</span><span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">])</span> <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">changepoints</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">)]</span>
    <span class="k">for</span> <span class="n">d</span> <span class="ow">in</span> <span class="n">delims</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="nb">abs</span><span class="p">(</span><span class="n">d</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">d</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
        <span class="n">p</span> <span class="o">=</span> <span class="n">Period</span><span class="p">(</span><span class="n">d</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span><span class="n">d</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">)</span>
        <span class="n">p</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span><span class="p">)</span>
        <span class="n">p</span><span class="o">.</span><span class="n">update_color</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span><span class="p">,</span> <span class="n">color_map</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">color_map</span><span class="p">)</span>
        <span class="n">periods</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">periods</span></div>

<div class="viewcode-block" id="ZScoreDetector.merge_similar"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.merge_similar">[docs]</a>  <span class="k">def</span> <span class="nf">merge_similar</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">periods</span><span class="p">,</span> <span class="n">min_length</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Recursively combine similar periods or periods smaller than min length into</span>
<span class="sd">    larger periods.</span>

<span class="sd">    :param periods: List of Period objects</span>
<span class="sd">    :param min_length: minimum season length</span>

<span class="sd">    :returns: List of Period objects</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">periods_copy</span>  <span class="o">=</span> <span class="n">periods</span>
    <span class="n">short_periods</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">periods</span><span class="p">[</span><span class="mi">1</span><span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">length</span><span class="p">()</span> <span class="o">&lt;</span> <span class="n">min_length</span><span class="p">):</span>
        <span class="n">short_periods</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">short_periods</span><span class="p">)</span> <span class="o">&lt;=</span> <span class="mi">0</span><span class="p">):</span>
      <span class="k">return</span> <span class="n">periods_copy</span>

    <span class="k">for</span> <span class="n">curr_p</span> <span class="ow">in</span> <span class="n">short_periods</span><span class="p">:</span>
      <span class="k">try</span><span class="p">:</span>
        <span class="n">curr_sig</span>   <span class="o">=</span> <span class="n">curr_p</span><span class="o">.</span><span class="n">rgb</span>
        <span class="n">skip</span> <span class="o">=</span> <span class="bp">False</span>
        <span class="n">prev_p</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">periods</span> <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">x1</span> <span class="o">==</span> <span class="n">curr_p</span><span class="o">.</span><span class="n">x0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">prev_sig</span> <span class="o">=</span> <span class="n">prev_p</span><span class="o">.</span><span class="n">rgb</span>

        <span class="n">next_p</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">periods</span> <span class="k">if</span> <span class="n">x</span><span class="o">.</span><span class="n">x0</span> <span class="o">==</span> <span class="n">curr_p</span><span class="o">.</span><span class="n">x1</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">next_sig</span> <span class="o">=</span> <span class="n">next_p</span><span class="o">.</span><span class="n">rgb</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">linalg</span><span class="o">.</span><span class="n">norm</span><span class="p">(</span><span class="n">curr_sig</span> <span class="o">-</span> <span class="n">prev_sig</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">linalg</span><span class="o">.</span><span class="n">norm</span><span class="p">(</span><span class="n">next_sig</span> <span class="o">-</span> <span class="n">curr_sig</span><span class="p">)):</span>
          <span class="n">next_p</span><span class="o">.</span><span class="n">update_pos</span><span class="p">([</span><span class="n">curr_p</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="n">next_p</span><span class="o">.</span><span class="n">x1</span><span class="p">])</span>
          <span class="n">next_p</span><span class="o">.</span><span class="n">update_color</span><span class="p">(</span><span class="n">color_cols</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span><span class="p">,</span> <span class="n">color_map</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">color_map</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
          <span class="n">prev_p</span><span class="o">.</span><span class="n">update_pos</span><span class="p">([</span><span class="n">prev_p</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="n">curr_p</span><span class="o">.</span><span class="n">x1</span><span class="p">])</span>
          <span class="n">prev_p</span><span class="o">.</span><span class="n">update_color</span><span class="p">(</span><span class="n">color_cols</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span><span class="p">,</span> <span class="n">color_map</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">color_map</span><span class="p">)</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">curr_p</span><span class="o">.</span><span class="n">vspan</span> <span class="o">!=</span> <span class="bp">None</span><span class="p">):</span>
          <span class="n">curr_p</span><span class="o">.</span><span class="n">vspan</span><span class="o">.</span><span class="n">remove</span><span class="p">()</span>
        <span class="k">del</span> <span class="n">periods_copy</span><span class="p">[</span><span class="n">periods_copy</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">curr_p</span><span class="p">)]</span>
      <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">log</span><span class="o">.</span><span class="n">dbg</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>
        <span class="k">continue</span>

    <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">merge_similar</span><span class="p">(</span><span class="n">periods_copy</span><span class="p">,</span> <span class="n">min_length</span><span class="p">)</span></div>

<div class="viewcode-block" id="ZScoreDetector.merge_equal"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.merge_equal">[docs]</a>  <span class="k">def</span> <span class="nf">merge_equal</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">periods</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Merge identical periods</span>
<span class="sd">    :param periods: List of Periods (which may contain duplicates)</span>
<span class="sd">    :returns:       List of Periods with duplicates removed</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">zipped</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="n">periods</span><span class="p">,</span> <span class="n">periods</span><span class="p">)</span>
    <span class="n">nperiods</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">zipped</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">p</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">hex</span> <span class="o">==</span> <span class="n">p</span><span class="p">[</span><span class="mi">1</span><span class="p">]):</span>
        <span class="n">p</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">update_pos</span><span class="p">((</span><span class="n">p</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span><span class="n">p</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">x1</span><span class="p">))</span>
        <span class="n">nperiods</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
      <span class="k">else</span><span class="p">:</span>
        <span class="n">nperiods</span> <span class="o">+=</span> <span class="nb">list</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">nperiods</span></div>

<div class="viewcode-block" id="ZScoreDetector.finalize"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.finalize">[docs]</a>  <span class="k">def</span> <span class="nf">finalize</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">operiods</span><span class="p">,</span> <span class="n">periods</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Finalization and cleanup.</span>
<span class="sd">    TODO: Use a bigger sliding window with padding of real values to establish endpoints.</span>
<span class="sd">    :param operiods: Original period definitions</span>
<span class="sd">    :param periods: Cleaned period definitions</span>
<span class="sd">    :returns:       tuple(operiods, periods)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">is_circular</span><span class="p">):</span>
      <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">periods</span><span class="p">:</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">x0</span> <span class="o">&gt;=</span> <span class="mi">366</span><span class="p">):</span>
          <span class="n">p</span><span class="o">.</span><span class="n">x0</span> <span class="o">-=</span> <span class="mi">366</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">&gt;=</span> <span class="mi">366</span><span class="p">):</span>
          <span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">-=</span> <span class="mi">366</span>

      <span class="n">new_periods</span> <span class="o">=</span> <span class="p">[]</span>
      <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">periods</span><span class="p">:</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">&gt;</span> <span class="n">p</span><span class="o">.</span><span class="n">x0</span><span class="p">):</span>
          <span class="n">new_periods</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
          <span class="c1"># if (new_periods[0].x1 &lt; p.x1):</span>
          <span class="c1">#   new_periods[0].x1 = int(p.x1)</span>
          <span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">=</span> <span class="mi">366</span>
          <span class="n">new_periods</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">p</span><span class="p">)</span>

          <span class="n">new_periods</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">median_sig</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">median_sig</span>
          <span class="n">new_periods</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">avg_sig</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">avg_sig</span>
          <span class="n">new_periods</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">rgb</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">rgb</span>
          <span class="n">new_periods</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">hex</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">hex</span>
          <span class="n">new_periods</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">p</span><span class="o">.</span><span class="n">name</span>
          <span class="k">break</span>

      <span class="n">periods</span> <span class="o">=</span> <span class="n">new_periods</span>

    <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">periods</span><span class="p">:</span>
      <span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">-=</span> <span class="mi">1</span>

    <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">operiods</span><span class="p">:</span>
      <span class="n">o</span><span class="o">.</span><span class="n">x1</span> <span class="o">-=</span> <span class="mi">1</span>

    <span class="k">return</span> <span class="p">(</span><span class="n">operiods</span><span class="p">,</span> <span class="n">periods</span><span class="p">)</span></div>

<div class="viewcode-block" id="ZScoreDetector.run"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.changedetection.ZScoreDetector.run">[docs]</a>  <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ycol</span><span class="p">,</span> <span class="n">iwindow_size</span><span class="p">,</span> <span class="n">owindow_size</span><span class="p">,</span> <span class="n">min_length</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Run the season algorithm.</span>
<span class="sd">    Selects the relevant timeseries (usually a PCA-reduced dataset).</span>
<span class="sd">    Calculate diffs, zscores, changewindows, changepoints and determine the final seasons.</span>
<span class="sd">    Then finally does some cleanup on the calculated periods.</span>

<span class="sd">    :param ycol: The name of the column which contains the basis for the season calculation</span>
<span class="sd">    :param iwindow_size: inner window size</span>
<span class="sd">    :param owindow_size: outer window size</span>
<span class="sd">    :param min_length: minimum season length</span>
<span class="sd">    :returns:       Results, dictionary {</span>
<span class="sd">    &#39;df&#39;: # The underlying data (dataframe),</span>
<span class="sd">    &#39;color_cols&#39;: Columns to be used for colorization,</span>
<span class="sd">    &#39;ycol&#39;: Column which is the basis for the season calculation (e.g. PCA1)</span>
<span class="sd">    &#39;diffs&#39;: Differences,</span>
<span class="sd">    &#39;z_scores&#39;: Z-Scores,</span>
<span class="sd">    &#39;cws&#39;: Change windows,</span>
<span class="sd">    &#39;cps&#39;: Changepoints,</span>
<span class="sd">    &#39;operiods&#39;: Original periods before cleanup,</span>
<span class="sd">    &#39;periods&#39;: Actual periods / Seasons,</span>
<span class="sd">    &#39;iw_size&#39;: Inner window size used in the calculation,</span>
<span class="sd">    &#39;ow_size&#39;: Outer window size used in the calculation,</span>
<span class="sd">    &#39;min_length&#39;: Minimum season length</span>
<span class="sd">    }</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">y</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[</span><span class="n">ycol</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span>   <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">([</span><span class="mf">0.0</span><span class="p">]</span> <span class="o">+</span> <span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">,</span><span class="mi">2</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span> <span class="o">+</span> <span class="p">[</span><span class="mf">0.0</span><span class="p">])</span>
    <span class="n">z_scores</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">calculate_zscores</span><span class="p">(</span><span class="n">iwindow_size</span><span class="p">,</span> <span class="n">owindow_size</span><span class="p">)</span>

    <span class="c1"># Scale</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">({</span><span class="s1">&#39;y&#39;</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">y</span><span class="p">,</span> <span class="s1">&#39;z_scores&#39;</span><span class="p">:</span><span class="n">z_scores</span><span class="p">,</span> <span class="s1">&#39;diffs&#39;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">diffs</span><span class="p">})</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">scaling</span><span class="o">.</span><span class="n">Scaler</span><span class="p">(</span><span class="n">method</span><span class="o">=</span><span class="s1">&#39;min_max&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">fit</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">low</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">high</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">transform</span><span class="p">(</span><span class="n">df</span><span class="p">)</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">y</span>     <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="s1">&#39;y&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span> <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="s1">&#39;diffs&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
    <span class="n">z_scores</span>   <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="s1">&#39;z_scores&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>

    <span class="n">cws</span>      <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">calculate_change_windows</span><span class="p">(</span><span class="n">z_scores</span><span class="p">,</span> <span class="n">owindow_size</span><span class="p">)</span>
    <span class="n">cps</span>      <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">calculate_changepoints</span><span class="p">(</span><span class="n">cws</span><span class="p">)</span>
    <span class="n">operiods</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">define_periods</span><span class="p">(</span><span class="n">cps</span><span class="p">)</span>

    <span class="n">periods</span>  <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">merge_similar</span><span class="p">(</span><span class="n">copy</span><span class="o">.</span><span class="n">deepcopy</span><span class="p">(</span><span class="n">operiods</span><span class="p">),</span> <span class="n">min_length</span><span class="o">=</span><span class="n">min_length</span><span class="p">)</span>

    <span class="n">operiods</span><span class="p">,</span> <span class="n">periods</span>  <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">finalize</span><span class="p">(</span><span class="n">operiods</span><span class="p">,</span> <span class="n">periods</span><span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">is_circular</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">[:</span><span class="mi">366</span><span class="p">]</span>
      <span class="n">operiods</span> <span class="o">=</span> <span class="p">[</span><span class="n">p</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">operiods</span> <span class="k">if</span> <span class="n">p</span><span class="o">.</span><span class="n">x1</span> <span class="o">&lt;=</span> <span class="mi">365</span><span class="p">]</span>
      <span class="n">cps</span> <span class="o">=</span> <span class="p">[</span><span class="n">cp</span> <span class="k">for</span> <span class="n">cp</span> <span class="ow">in</span> <span class="n">cps</span> <span class="k">if</span> <span class="n">cp</span> <span class="o">&lt;=</span> <span class="mi">365</span><span class="p">]</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">diffs</span><span class="p">[:</span><span class="mi">366</span><span class="p">]</span>
      <span class="n">z_scores</span> <span class="o">=</span> <span class="n">z_scores</span><span class="p">[:</span><span class="mi">366</span><span class="p">]</span>

    <span class="n">resdict</span> <span class="o">=</span> <span class="p">{</span>
      <span class="s1">&#39;df&#39;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span>
      <span class="s1">&#39;color_cols&#39;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">color_cols</span><span class="p">,</span>
      <span class="s1">&#39;ycol&#39;</span><span class="p">:</span><span class="n">ycol</span><span class="p">,</span>
      <span class="s1">&#39;diffs&#39;</span><span class="p">:</span><span class="bp">self</span><span class="o">.</span><span class="n">diffs</span><span class="p">,</span>
      <span class="s1">&#39;z_scores&#39;</span><span class="p">:</span><span class="n">z_scores</span><span class="p">,</span>
      <span class="s1">&#39;cws&#39;</span><span class="p">:</span><span class="n">cws</span><span class="p">,</span>
      <span class="s1">&#39;cps&#39;</span><span class="p">:</span><span class="n">cps</span><span class="p">,</span>
      <span class="s1">&#39;operiods&#39;</span><span class="p">:</span><span class="n">operiods</span><span class="p">,</span>
      <span class="s1">&#39;periods&#39;</span><span class="p">:</span><span class="n">periods</span><span class="p">,</span>
      <span class="s1">&#39;iw_size&#39;</span><span class="p">:</span><span class="n">iwindow_size</span><span class="p">,</span>
      <span class="s1">&#39;ow_size&#39;</span><span class="p">:</span><span class="n">owindow_size</span><span class="p">,</span>
      <span class="s1">&#39;min_length&#39;</span><span class="p">:</span><span class="n">min_length</span>
    <span class="p">}</span>

    <span class="k">return</span> <span class="n">resdict</span></div></div>


</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>